=== modified file 'bzrlib/selftest/testbranch.py'
--- bzrlib/selftest/testbranch.py	2005-10-07 04:10:46 +0000
+++ bzrlib/selftest/testbranch.py	2005-10-08 06:41:21 +0000
@@ -19,11 +19,11 @@
 from bzrlib.clone import copy_branch
 from bzrlib.commit import commit
 import bzrlib.errors as errors
-from bzrlib.errors import NoSuchRevision, UnlistableBranch
+from bzrlib.errors import NoSuchRevision, UnlistableBranch, NotBranchError
 from bzrlib.selftest import TestCaseInTempDir
 from bzrlib.trace import mutter
 import bzrlib.transactions as transactions
-
+from bzrlib.selftest.HTTPTestUtil import TestCaseWithWebserver
 
 class TestBranch(TestCaseInTempDir):
 
@@ -141,7 +141,16 @@
         # list should be cleared when we do a commit
         self.assertEquals(b.pending_merges(), [])
  
-
+class TestRemote(TestCaseWithWebserver):
+    def test_open_containing(self):
+        self.assertRaises(NotBranchError, Branch.open_containing,
+                          self.get_remote_url(''))
+        self.assertRaises(NotBranchError, Branch.open_containing,
+                          self.get_remote_url('g/p/q'))
+        b = Branch.initialize('.')
+        Branch.open_containing(self.get_remote_url(''))
+        Branch.open_containing(self.get_remote_url('g/p/q'))
+        
 # TODO: rewrite this as a regular unittest, without relying on the displayed output        
 #         >>> from bzrlib.commit import commit
 #         >>> bzrlib.trace.silent = True

=== modified file 'bzrlib/transport/http.py'
--- bzrlib/transport/http.py	2005-10-04 04:37:29 +0000
+++ bzrlib/transport/http.py	2005-10-08 06:41:21 +0000
@@ -89,7 +89,8 @@
                     # In most filesystems, a request for the parent
                     # of root, just returns root.
                     continue
-                basepath.pop()
+                if len(basepath) > 0:
+                    basepath.pop()
             elif p == '.':
                 continue # No-op
             else:

